class EntertainmentOperations

  # Rating operations - objects must have Rating

  def self.sortByRating(objectArray)
    # sorts in ascending order of rating:
    unless defined?(objectArray[0].rating)
      puts "Object does not have rating."
      return
    end

    objectArray.sort_by {|m| m.rating}
  end

  def self.getHighestRated(objectArray)
    objectArray = sortByRating(objectArray)
    puts objectArray.last
  end

  def self.getLowestRated(objectArray)
    objectArray = sortByRating(objectArray)
    puts objectArray.first
  end

  def self.cutLowestRatedHalf(objectArray)
    objectArray = sortByRating(objectArray).reverse
    objectArray.drop(objectArray.length/2)
  end

  def self.printSortedListByRating(objectArray)
    objectArray = sortByRating(objectArray)
    objectArray.each {|obj| puts obj}
  end

  # Title operations - objects must have title

  def self.sortByTitle(objectArray)
    # sorts by name alphabetically
    unless defined?(objectArray[0].title)
      puts "Object does not have title."
      return
    end

    objectArray.sort_by {|m| m.title.downcase}
  end

  def self.printSortedListByTitle(objectArray)
    objectArray = sortByTitle(objectArray)
    objectArray.each {|obj| puts obj}
  end

  # Genre operations - objects must have genre

  def self.sortByGenre(objectArray)
    # sorts by genre alphabetically
    unless defined?(objectArray[0].genre)
      puts "Object does not have genre."
      return
    end

    objectArray.sort_by {|m| m.genre.downcase}
  end

  def self.printSortedListByGenre(objectArray)
    objectArray = sortByGenre(objectArray)
    objectArray.each {|obj| puts obj}
  end

  # Category operations - objects must have category array

  def self.sortByCategory(objectArray, categoryNumber)
    # sorts by category alphabetically
    unless defined?(objectArray[categoryNumber].category.first)
      puts "Object must have category array."
      return
    end

    objectArray.sort_by {|m| m.category.first.downcase}
  end

  def self.printSortedListByCategory(objectArray, categoryNumber)
    objectArray = sortByCategory(objectArray, categoryNumber)
    objectArray.each {|obj| puts obj}
  end
end
